<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.efm.borndie.matrix;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.IOException;<a name="line.36"></a>
<FONT color="green">037</FONT>    <a name="line.37"></a>
<FONT color="green">038</FONT>    import ch.javasoft.metabolic.efm.borndie.job.PairingJob;<a name="line.38"></a>
<FONT color="green">039</FONT>    import ch.javasoft.metabolic.efm.borndie.range.LowerTriangularMatrix;<a name="line.39"></a>
<FONT color="green">040</FONT>    import ch.javasoft.metabolic.efm.column.Column;<a name="line.40"></a>
<FONT color="green">041</FONT>    import ch.javasoft.metabolic.efm.memory.AppendableMemory;<a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.metabolic.efm.memory.IterableMemory;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.metabolic.efm.memory.SortableMemory;<a name="line.43"></a>
<FONT color="green">044</FONT>    <a name="line.44"></a>
<FONT color="green">045</FONT>    /**<a name="line.45"></a>
<FONT color="green">046</FONT>     * The &lt;code&gt;BornDieMatrix&lt;/code&gt; is a lower triangular matrix containing cells<a name="line.46"></a>
<FONT color="green">047</FONT>     * with intermediary rows. The row of the cell encodes for the die index, the<a name="line.47"></a>
<FONT color="green">048</FONT>     * column for the birth index.<a name="line.48"></a>
<FONT color="green">049</FONT>     * &lt;p&gt;<a name="line.49"></a>
<FONT color="green">050</FONT>     * Note that the matrix contains n+1 columns and rows, where n is the number of<a name="line.50"></a>
<FONT color="green">051</FONT>     * sequential iteration steps. Columns in the cell [i,j] are born during<a name="line.51"></a>
<FONT color="green">052</FONT>     * iteration j, where the first column 0 contains modes from the initial <a name="line.52"></a>
<FONT color="green">053</FONT>     * matrix, and the last column n contains modes born during the last <a name="line.53"></a>
<FONT color="green">054</FONT>     * iteration. The first row 0 contains modes which become infeasible at <a name="line.54"></a>
<FONT color="green">055</FONT>     * iteration 1, the second last row n-1 contains modes dying during the last<a name="line.55"></a>
<FONT color="green">056</FONT>     * iteration, and row n contains the final modes (the algorithm's result).<a name="line.56"></a>
<FONT color="green">057</FONT>     * &lt;p&gt;<a name="line.57"></a>
<FONT color="green">058</FONT>     * For instance, cell [4,1] contains modes born in the first iteration step,<a name="line.58"></a>
<FONT color="green">059</FONT>     * becoming infeasible during the 3rd iteration step.<a name="line.59"></a>
<FONT color="green">060</FONT>     * <a name="line.60"></a>
<FONT color="green">061</FONT>     * @type Col the column type of the columns (representing modes) stored in the <a name="line.61"></a>
<FONT color="green">062</FONT>     *                      matrix cells<a name="line.62"></a>
<FONT color="green">063</FONT>     */<a name="line.63"></a>
<FONT color="green">064</FONT>    public interface BornDieMatrix&lt;Col extends Column&gt; {<a name="line.64"></a>
<FONT color="green">065</FONT>            /**<a name="line.65"></a>
<FONT color="green">066</FONT>             * Returns the cell stage for the specified cell.<a name="line.66"></a>
<FONT color="green">067</FONT>             * <a name="line.67"></a>
<FONT color="green">068</FONT>             * @param bornCol       the born index, from 0 to n, i.e. n+1 columns for n iterations<a name="line.68"></a>
<FONT color="green">069</FONT>             * @param dieRow        the die index, from 0 to n, i.e. n+1 rows for n iterations<a name="line.69"></a>
<FONT color="green">070</FONT>             * <a name="line.70"></a>
<FONT color="green">071</FONT>             * @return the cell stage for the specified cell<a name="line.71"></a>
<FONT color="green">072</FONT>             * @throws IndexOutOfBoundsException    if row or col is negative, or if row<a name="line.72"></a>
<FONT color="green">073</FONT>             *                                                                              or col is larger than the number of<a name="line.73"></a>
<FONT color="green">074</FONT>             *                                                                              iterations, or if col &gt; row.<a name="line.74"></a>
<FONT color="green">075</FONT>             */<a name="line.75"></a>
<FONT color="green">076</FONT>            CellStage getCellStage(int bornCol, int dieRow);<a name="line.76"></a>
<FONT color="green">077</FONT>    <a name="line.77"></a>
<FONT color="green">078</FONT>    //      /**<a name="line.78"></a>
<FONT color="green">079</FONT>    //       * The cell switches to the next stage. No stages are skipped, the caller<a name="line.79"></a>
<FONT color="green">080</FONT>    //       * has to trigger another stage change to skip stages. Skipping stages might<a name="line.80"></a>
<FONT color="green">081</FONT>    //       * for instance be desired if a cell leaves the accumulating stage and <a name="line.81"></a>
<FONT color="green">082</FONT>    //       * contains no modes.<a name="line.82"></a>
<FONT color="green">083</FONT>    //       * &lt;p&gt;<a name="line.83"></a>
<FONT color="green">084</FONT>    //       * &lt;p&gt;<a name="line.84"></a>
<FONT color="green">085</FONT>    //       * To handle concurrent calls, the cell's current stage has to be specified.<a name="line.85"></a>
<FONT color="green">086</FONT>    //       * The cell might already be in a subsequent stage, and no stage change is<a name="line.86"></a>
<FONT color="green">087</FONT>    //       * necessary. If the specified stage equals the cell's current stage, the <a name="line.87"></a>
<FONT color="green">088</FONT>    //       * cell changes to the next stage. Otherwise, the cell was already in a <a name="line.88"></a>
<FONT color="green">089</FONT>    //       * subsequent stage. The method returns true if the cell stage was changed.<a name="line.89"></a>
<FONT color="green">090</FONT>    //       * <a name="line.90"></a>
<FONT color="green">091</FONT>    //       * @param bornCol               the column index of this cell in the matrix<a name="line.91"></a>
<FONT color="green">092</FONT>    //       * @param dieRow                the row index of this cell in the matrix<a name="line.92"></a>
<FONT color="green">093</FONT>    //       * @param currentStage  the current cell stage<a name="line.93"></a>
<FONT color="green">094</FONT>    //       * <a name="line.94"></a>
<FONT color="green">095</FONT>    //       * @return      true if the cell stage was changed, and false if it was already<a name="line.95"></a>
<FONT color="green">096</FONT>    //       *                      in a stage subsequent to the specified current stage<a name="line.96"></a>
<FONT color="green">097</FONT>    //       * <a name="line.97"></a>
<FONT color="green">098</FONT>    //       * @throws IOException  if an i/o exception occurs, e.g. when a new <a name="line.98"></a>
<FONT color="green">099</FONT>    //       *                                              file-based memory instantiation fails<a name="line.99"></a>
<FONT color="green">100</FONT>    //       * @throws IndexOutOfBoundsException    if row or col is negative, or if row<a name="line.100"></a>
<FONT color="green">101</FONT>    //       *                                                                              or col is larger than the number of<a name="line.101"></a>
<FONT color="green">102</FONT>    //       *                                                                              iterations, or if col &gt; row.<a name="line.102"></a>
<FONT color="green">103</FONT>    //       */<a name="line.103"></a>
<FONT color="green">104</FONT>    //      boolean switchCellStage(int bornCol, int dieRow, CellStage currentStage) throws IOException;<a name="line.104"></a>
<FONT color="green">105</FONT>            <a name="line.105"></a>
<FONT color="green">106</FONT>            /**<a name="line.106"></a>
<FONT color="green">107</FONT>             * Returns an object representing the lower triangular matrix of this <a name="line.107"></a>
<FONT color="green">108</FONT>             * born-die matrix<a name="line.108"></a>
<FONT color="green">109</FONT>             */<a name="line.109"></a>
<FONT color="green">110</FONT>            LowerTriangularMatrix getMatrixRange();<a name="line.110"></a>
<FONT color="green">111</FONT>            <a name="line.111"></a>
<FONT color="green">112</FONT>            /**<a name="line.112"></a>
<FONT color="green">113</FONT>             * Returns the number of iterations, defining the matrix size. For n <a name="line.113"></a>
<FONT color="green">114</FONT>             * iterations, the lower-triangular matrix has n+1 rows and columns, i.e.<a name="line.114"></a>
<FONT color="green">115</FONT>             * valid row/col indices range from 0..n (both inclusive). <a name="line.115"></a>
<FONT color="green">116</FONT>             */<a name="line.116"></a>
<FONT color="green">117</FONT>            int getIterationCount();<a name="line.117"></a>
<FONT color="green">118</FONT>            <a name="line.118"></a>
<FONT color="green">119</FONT>            /**<a name="line.119"></a>
<FONT color="green">120</FONT>             * Creates and schedules all pairing jobs for the specified cell, with <a name="line.120"></a>
<FONT color="green">121</FONT>             * partner cells in the specified active columns. If the cell is not in the <a name="line.121"></a>
<FONT color="green">122</FONT>             * {@link CellStage#Bearing bearing} stage, or if the specified columns are <a name="line.122"></a>
<FONT color="green">123</FONT>             * not containing partner cells (according to the {@link PairingRule}), an<a name="line.123"></a>
<FONT color="green">124</FONT>             * exception is thrown.<a name="line.124"></a>
<FONT color="green">125</FONT>             * <a name="line.125"></a>
<FONT color="green">126</FONT>             * @param bornCol                               the column index of the bearing cell<a name="line.126"></a>
<FONT color="green">127</FONT>             * @param dieRow                                the row index of the bearing cell<a name="line.127"></a>
<FONT color="green">128</FONT>             * @param activeBornColumnFrom  the first column with partner cells, <a name="line.128"></a>
<FONT color="green">129</FONT>             *                                                              inclusive<a name="line.129"></a>
<FONT color="green">130</FONT>             * @param activeBornColumnTo    the last column with partner cells, <a name="line.130"></a>
<FONT color="green">131</FONT>             *                                                              exclusive <a name="line.131"></a>
<FONT color="green">132</FONT>             * @throws IOException  if an i/o exception occurs, e.g. when a new <a name="line.132"></a>
<FONT color="green">133</FONT>             *                                              file-based memory instantiation fails<a name="line.133"></a>
<FONT color="green">134</FONT>             * @throws IllegalStateException if this cell is not in the <a name="line.134"></a>
<FONT color="green">135</FONT>             *                      {@link CellStage#Bearing bearing} stage<a name="line.135"></a>
<FONT color="green">136</FONT>             * @throws IllegalArgumentException if the columns are not partner columns<a name="line.136"></a>
<FONT color="green">137</FONT>             *                      of this cell, according to the {@link PairingRule}<a name="line.137"></a>
<FONT color="green">138</FONT>             */<a name="line.138"></a>
<FONT color="green">139</FONT>            void schedulePairingJobs(int bornCol, int dieRow, int activeBornColumnFrom, int activeBornColumnTo) throws IOException, IllegalStateException, IllegalArgumentException;        <a name="line.139"></a>
<FONT color="green">140</FONT>            /**<a name="line.140"></a>
<FONT color="green">141</FONT>             * Notify that all modes have been added to the initial column, that is, the<a name="line.141"></a>
<FONT color="green">142</FONT>             * first column is ready to start pairing jobs now<a name="line.142"></a>
<FONT color="green">143</FONT>             * <a name="line.143"></a>
<FONT color="green">144</FONT>             * @throws IOException  if an i/o exception occurs, e.g. due to file-based <a name="line.144"></a>
<FONT color="green">145</FONT>             *                                              memory<a name="line.145"></a>
<FONT color="green">146</FONT>             */<a name="line.146"></a>
<FONT color="green">147</FONT>            void notifyInitialColumnComplete() throws IOException;<a name="line.147"></a>
<FONT color="green">148</FONT>    //      /**<a name="line.148"></a>
<FONT color="green">149</FONT>    //       * Notify that all pairing jobs of the specified {@code owner} cell are<a name="line.149"></a>
<FONT color="green">150</FONT>    //       * empty, since the cell contains no modes<a name="line.150"></a>
<FONT color="green">151</FONT>    //       * <a name="line.151"></a>
<FONT color="green">152</FONT>    //       * @param owner owner cell, containing dying modes of the pairing jobs<a name="line.152"></a>
<FONT color="green">153</FONT>    //       * @throws IOException  if an i/o exception occurs, e.g. due to file-based <a name="line.153"></a>
<FONT color="green">154</FONT>    //       *                                              memory<a name="line.154"></a>
<FONT color="green">155</FONT>    //       */<a name="line.155"></a>
<FONT color="green">156</FONT>    //      void notifyAllJobsEmpty(CellRange owner) throws IOException;<a name="line.156"></a>
<FONT color="green">157</FONT>            /**<a name="line.157"></a>
<FONT color="green">158</FONT>             * Notify about the completion of a {@link PairingJob pairing job}<a name="line.158"></a>
<FONT color="green">159</FONT>             * <a name="line.159"></a>
<FONT color="green">160</FONT>             * @param job   the completed job<a name="line.160"></a>
<FONT color="green">161</FONT>             */<a name="line.161"></a>
<FONT color="green">162</FONT>            void notifyPairingJobCompleted(PairingJob&lt;Col&gt; job) throws IOException;<a name="line.162"></a>
<FONT color="green">163</FONT>            /**<a name="line.163"></a>
<FONT color="green">164</FONT>             * Returns the memory for appending modes to the cell in the born-die <a name="line.164"></a>
<FONT color="green">165</FONT>             * matrix.<a name="line.165"></a>
<FONT color="green">166</FONT>             * <a name="line.166"></a>
<FONT color="green">167</FONT>             * @param bornCol       the born index, from 0 to n, i.e. n+1 columns for n iterations<a name="line.167"></a>
<FONT color="green">168</FONT>             * @param dieRow        the die index, from 0 to n, i.e. n+1 rows for n iterations<a name="line.168"></a>
<FONT color="green">169</FONT>             * <a name="line.169"></a>
<FONT color="green">170</FONT>             * @return the memory for appending<a name="line.170"></a>
<FONT color="green">171</FONT>             * <a name="line.171"></a>
<FONT color="green">172</FONT>             * @throws IllegalStateException                if this cell is neither in the<a name="line.172"></a>
<FONT color="green">173</FONT>             *                                                                              {@link CellStage#Accumulating Accumulating} stage<a name="line.173"></a>
<FONT color="green">174</FONT>             * @throws IndexOutOfBoundsException    if row or col is negative, or if row<a name="line.174"></a>
<FONT color="green">175</FONT>             *                                                                              or col is larger than the number of<a name="line.175"></a>
<FONT color="green">176</FONT>             *                                                                              iterations, or if col &gt; row.<a name="line.176"></a>
<FONT color="green">177</FONT>             * @throws IOException  if an i/o exception occurs, e.g. due to file-based <a name="line.177"></a>
<FONT color="green">178</FONT>             *                                              memory<a name="line.178"></a>
<FONT color="green">179</FONT>             */<a name="line.179"></a>
<FONT color="green">180</FONT>            AppendableMemory&lt;Col&gt; getForAppending(int bornCol, int dieRow) throws IllegalStateException, IOException;<a name="line.180"></a>
<FONT color="green">181</FONT>    <a name="line.181"></a>
<FONT color="green">182</FONT>            /**<a name="line.182"></a>
<FONT color="green">183</FONT>             * Returns the memory for the generation of new modes from adjacent modes <a name="line.183"></a>
<FONT color="green">184</FONT>             * resulting from the pairing of two generating memories, one for negative<a name="line.184"></a>
<FONT color="green">185</FONT>             * and one for positive modes. Here, all dying modes are returned.<a name="line.185"></a>
<FONT color="green">186</FONT>             * <a name="line.186"></a>
<FONT color="green">187</FONT>             * @param bornCol       the born index, from 0 to n, i.e. n+1 columns for n iterations<a name="line.187"></a>
<FONT color="green">188</FONT>             * @param dieRow        the die index, from 0 to n, i.e. n+1 rows for n iterations<a name="line.188"></a>
<FONT color="green">189</FONT>             * <a name="line.189"></a>
<FONT color="green">190</FONT>             * @return the memory for reading or sorting<a name="line.190"></a>
<FONT color="green">191</FONT>             * <a name="line.191"></a>
<FONT color="green">192</FONT>             * @throws IllegalStateException                if this cell is not in an<a name="line.192"></a>
<FONT color="green">193</FONT>             *                                                                              {@link CellStage#isActive() active} <a name="line.193"></a>
<FONT color="green">194</FONT>             *                                                                              stage<a name="line.194"></a>
<FONT color="green">195</FONT>             * @throws IndexOutOfBoundsException    if row or col is negative, or if row<a name="line.195"></a>
<FONT color="green">196</FONT>             *                                                                              or col is larger than the number of<a name="line.196"></a>
<FONT color="green">197</FONT>             *                                                                              iterations, or if col &gt; row.<a name="line.197"></a>
<FONT color="green">198</FONT>             * @throws IOException  if an i/o exception occurs, e.g. due to file-based <a name="line.198"></a>
<FONT color="green">199</FONT>             *                                              memory<a name="line.199"></a>
<FONT color="green">200</FONT>             */<a name="line.200"></a>
<FONT color="green">201</FONT>            SortableMemory&lt;Col&gt; getNegForGenerating(int bornCol, int dieRow) throws IllegalStateException, IOException;<a name="line.201"></a>
<FONT color="green">202</FONT>            /**<a name="line.202"></a>
<FONT color="green">203</FONT>             * Returns the memory for the generation of new modes from adjacent modes <a name="line.203"></a>
<FONT color="green">204</FONT>             * resulting from the pairing of two generating memories, one for negative<a name="line.204"></a>
<FONT color="green">205</FONT>             * and one for positive modes. Here, surviving modes for partners in dying<a name="line.205"></a>
<FONT color="green">206</FONT>             * row {@code partnerDyingRow} are returned.<a name="line.206"></a>
<FONT color="green">207</FONT>             * <a name="line.207"></a>
<FONT color="green">208</FONT>             * @param bornCol                       the born index, from 0 to n, i.e. n+1 columns for <a name="line.208"></a>
<FONT color="green">209</FONT>             *                                                      n iterations<a name="line.209"></a>
<FONT color="green">210</FONT>             * @param dieRow                        the die index, from 0 to n, i.e. n+1 rows for n <a name="line.210"></a>
<FONT color="green">211</FONT>             *                                                      iterations<a name="line.211"></a>
<FONT color="green">212</FONT>             * @param partnerDieRow         the die index, from dieRow + 1 to n<a name="line.212"></a>
<FONT color="green">213</FONT>             * <a name="line.213"></a>
<FONT color="green">214</FONT>             * @return the memory for reading or sorting<a name="line.214"></a>
<FONT color="green">215</FONT>             * <a name="line.215"></a>
<FONT color="green">216</FONT>             * @throws IllegalStateException                if this cell is not in an<a name="line.216"></a>
<FONT color="green">217</FONT>             *                                                                              {@link CellStage#isActive() active} <a name="line.217"></a>
<FONT color="green">218</FONT>             *                                                                              stage<a name="line.218"></a>
<FONT color="green">219</FONT>             * @throws IndexOutOfBoundsException    if row or col is negative, or if row<a name="line.219"></a>
<FONT color="green">220</FONT>             *                                                                              or col is larger than the number of<a name="line.220"></a>
<FONT color="green">221</FONT>             *                                                                              iterations, or if col &gt; row<a name="line.221"></a>
<FONT color="green">222</FONT>             * @throws IllegalArgumentException     if {@code partnerDyingRow} is not <a name="line.222"></a>
<FONT color="green">223</FONT>             *                                                                              greater than {@code dieRow}<a name="line.223"></a>
<FONT color="green">224</FONT>             *                                                                              iterations, or if col &gt; row<a name="line.224"></a>
<FONT color="green">225</FONT>             * @throws IOException  if an i/o exception occurs, e.g. due to file-based <a name="line.225"></a>
<FONT color="green">226</FONT>             *                                              memory<a name="line.226"></a>
<FONT color="green">227</FONT>             */<a name="line.227"></a>
<FONT color="green">228</FONT>            SortableMemory&lt;Col&gt; getPosForGenerating(int bornCol, int dieRow, int partnerDieRow) throws IllegalStateException, IOException;<a name="line.228"></a>
<FONT color="green">229</FONT>            /**<a name="line.229"></a>
<FONT color="green">230</FONT>             * Returns the memory at the specified cell (always the last row) containing<a name="line.230"></a>
<FONT color="green">231</FONT>             * the final modes.<a name="line.231"></a>
<FONT color="green">232</FONT>             * <a name="line.232"></a>
<FONT color="green">233</FONT>             * @param bornCol       the born index, from 0 to n, i.e. n+1 columns for n iterations<a name="line.233"></a>
<FONT color="green">234</FONT>             * <a name="line.234"></a>
<FONT color="green">235</FONT>             * @return the memory for reading<a name="line.235"></a>
<FONT color="green">236</FONT>             * <a name="line.236"></a>
<FONT color="green">237</FONT>             * @throws IllegalStateException                if this cell is not in the<a name="line.237"></a>
<FONT color="green">238</FONT>             *                                                                              {@link CellStage#Done Done} stage<a name="line.238"></a>
<FONT color="green">239</FONT>             * @throws IndexOutOfBoundsException    if col is negative or larger than <a name="line.239"></a>
<FONT color="green">240</FONT>             *                                                                              the number of iterations<a name="line.240"></a>
<FONT color="green">241</FONT>             * @throws IOException  if an i/o exception occurs, e.g. due to file-based <a name="line.241"></a>
<FONT color="green">242</FONT>             *                                              memory<a name="line.242"></a>
<FONT color="green">243</FONT>             */<a name="line.243"></a>
<FONT color="green">244</FONT>            IterableMemory&lt;Col&gt; getFinal(int bornCol) throws IllegalStateException, IOException;<a name="line.244"></a>
<FONT color="green">245</FONT>            <a name="line.245"></a>
<FONT color="green">246</FONT>            /**<a name="line.246"></a>
<FONT color="green">247</FONT>             * Returns the number of modes (aka columns) stored within the specified<a name="line.247"></a>
<FONT color="green">248</FONT>             * cell.<a name="line.248"></a>
<FONT color="green">249</FONT>             * <a name="line.249"></a>
<FONT color="green">250</FONT>             * @param bornCol       the born index, from 0 to n, i.e. n+1 columns for n iterations<a name="line.250"></a>
<FONT color="green">251</FONT>             * @param dieRow        the die index, from 0 to n, i.e. n+1 rows for n iterations<a name="line.251"></a>
<FONT color="green">252</FONT>             * <a name="line.252"></a>
<FONT color="green">253</FONT>             * @return the number of columns in the specified cell<a name="line.253"></a>
<FONT color="green">254</FONT>             * <a name="line.254"></a>
<FONT color="green">255</FONT>             * @throws IOException  if an i/o exception occurs, e.g. due to file-based <a name="line.255"></a>
<FONT color="green">256</FONT>             *                                              memory<a name="line.256"></a>
<FONT color="green">257</FONT>             */<a name="line.257"></a>
<FONT color="green">258</FONT>            int getColumnCount(int bornCol, int dieRow) throws IOException;<a name="line.258"></a>
<FONT color="green">259</FONT>    <a name="line.259"></a>
<FONT color="green">260</FONT>            /**<a name="line.260"></a>
<FONT color="green">261</FONT>             * Return true if the specified cell contains no modes.<a name="line.261"></a>
<FONT color="green">262</FONT>             * <a name="line.262"></a>
<FONT color="green">263</FONT>             * @param bornCol       the born index, from 0 to n, i.e. n+1 columns for n iterations<a name="line.263"></a>
<FONT color="green">264</FONT>             * @param dieRow        the die index, from 0 to n, i.e. n+1 rows for n iterations<a name="line.264"></a>
<FONT color="green">265</FONT>             * <a name="line.265"></a>
<FONT color="green">266</FONT>             * @return true if cell contains no modes<a name="line.266"></a>
<FONT color="green">267</FONT>             * <a name="line.267"></a>
<FONT color="green">268</FONT>             * @throws IndexOutOfBoundsException    if row or col is negative, or if row<a name="line.268"></a>
<FONT color="green">269</FONT>             *                                                                              or col is larger than the number of<a name="line.269"></a>
<FONT color="green">270</FONT>             *                                                                              iterations, or if col &gt; row.<a name="line.270"></a>
<FONT color="green">271</FONT>             * @throws IOException  if an i/o exception occurs, e.g. due to file-based <a name="line.271"></a>
<FONT color="green">272</FONT>             *                                              memory<a name="line.272"></a>
<FONT color="green">273</FONT>             */<a name="line.273"></a>
<FONT color="green">274</FONT>            boolean isEmpty(int bornCol, int dieRow) throws IOException;<a name="line.274"></a>
<FONT color="green">275</FONT>    }<a name="line.275"></a>




























































</PRE>
</BODY>
</HTML>
